/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMMediaTrackSupportedConstraints.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMMediaTrackSupportedConstraintsPrivate.h"
#include "WebKitDOMPrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

#define WEBKIT_DOM_MEDIA_TRACK_SUPPORTED_CONSTRAINTS_GET_PRIVATE(obj) G_TYPE_INSTANCE_GET_PRIVATE(obj, WEBKIT_DOM_TYPE_MEDIA_TRACK_SUPPORTED_CONSTRAINTS, WebKitDOMMediaTrackSupportedConstraintsPrivate)

typedef struct _WebKitDOMMediaTrackSupportedConstraintsPrivate {
#if ENABLE(MEDIA_STREAM)
    RefPtr<WebCore::MediaTrackSupportedConstraints> coreObject;
#endif // ENABLE(MEDIA_STREAM)
} WebKitDOMMediaTrackSupportedConstraintsPrivate;

#if ENABLE(MEDIA_STREAM)

namespace WebKit {

WebKitDOMMediaTrackSupportedConstraints* kit(WebCore::MediaTrackSupportedConstraints* obj)
{
    if (!obj)
        return 0;

    if (gpointer ret = DOMObjectCache::get(obj))
        return WEBKIT_DOM_MEDIA_TRACK_SUPPORTED_CONSTRAINTS(ret);

    return wrapMediaTrackSupportedConstraints(obj);
}

WebCore::MediaTrackSupportedConstraints* core(WebKitDOMMediaTrackSupportedConstraints* request)
{
    return request ? static_cast<WebCore::MediaTrackSupportedConstraints*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMMediaTrackSupportedConstraints* wrapMediaTrackSupportedConstraints(WebCore::MediaTrackSupportedConstraints* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_MEDIA_TRACK_SUPPORTED_CONSTRAINTS(g_object_new(WEBKIT_DOM_TYPE_MEDIA_TRACK_SUPPORTED_CONSTRAINTS, "core-object", coreObject, nullptr));
}

} // namespace WebKit

#endif // ENABLE(MEDIA_STREAM)

G_DEFINE_TYPE(WebKitDOMMediaTrackSupportedConstraints, webkit_dom_media_track_supported_constraints, WEBKIT_DOM_TYPE_OBJECT)

static void webkit_dom_media_track_supported_constraints_finalize(GObject* object)
{
    WebKitDOMMediaTrackSupportedConstraintsPrivate* priv = WEBKIT_DOM_MEDIA_TRACK_SUPPORTED_CONSTRAINTS_GET_PRIVATE(object);
#if ENABLE(MEDIA_STREAM)
    WebKit::DOMObjectCache::forget(priv->coreObject.get());
#endif // ENABLE(MEDIA_STREAM)
    priv->~WebKitDOMMediaTrackSupportedConstraintsPrivate();
    G_OBJECT_CLASS(webkit_dom_media_track_supported_constraints_parent_class)->finalize(object);
}

static GObject* webkit_dom_media_track_supported_constraints_constructor(GType type, guint constructPropertiesCount, GObjectConstructParam* constructProperties)
{
    GObject* object = G_OBJECT_CLASS(webkit_dom_media_track_supported_constraints_parent_class)->constructor(type, constructPropertiesCount, constructProperties);
#if ENABLE(MEDIA_STREAM)
    WebKitDOMMediaTrackSupportedConstraintsPrivate* priv = WEBKIT_DOM_MEDIA_TRACK_SUPPORTED_CONSTRAINTS_GET_PRIVATE(object);
    priv->coreObject = static_cast<WebCore::MediaTrackSupportedConstraints*>(WEBKIT_DOM_OBJECT(object)->coreObject);
    WebKit::DOMObjectCache::put(priv->coreObject.get(), object);
#endif // ENABLE(MEDIA_STREAM)
    return object;
}

static void webkit_dom_media_track_supported_constraints_class_init(WebKitDOMMediaTrackSupportedConstraintsClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    g_type_class_add_private(gobjectClass, sizeof(WebKitDOMMediaTrackSupportedConstraintsPrivate));
    gobjectClass->constructor = webkit_dom_media_track_supported_constraints_constructor;
    gobjectClass->finalize = webkit_dom_media_track_supported_constraints_finalize;
}

static void webkit_dom_media_track_supported_constraints_init(WebKitDOMMediaTrackSupportedConstraints* request)
{
    WebKitDOMMediaTrackSupportedConstraintsPrivate* priv = WEBKIT_DOM_MEDIA_TRACK_SUPPORTED_CONSTRAINTS_GET_PRIVATE(request);
    new (priv) WebKitDOMMediaTrackSupportedConstraintsPrivate();
}

