/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMVideoTrack.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMPrivate.h"
#include "WebKitDOMVideoTrackPrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

#define WEBKIT_DOM_VIDEO_TRACK_GET_PRIVATE(obj) G_TYPE_INSTANCE_GET_PRIVATE(obj, WEBKIT_DOM_TYPE_VIDEO_TRACK, WebKitDOMVideoTrackPrivate)

typedef struct _WebKitDOMVideoTrackPrivate {
#if ENABLE(VIDEO_TRACK)
    RefPtr<WebCore::VideoTrack> coreObject;
#endif // ENABLE(VIDEO_TRACK)
} WebKitDOMVideoTrackPrivate;

#if ENABLE(VIDEO_TRACK)

namespace WebKit {

WebKitDOMVideoTrack* kit(WebCore::VideoTrack* obj)
{
    if (!obj)
        return 0;

    if (gpointer ret = DOMObjectCache::get(obj))
        return WEBKIT_DOM_VIDEO_TRACK(ret);

    return wrapVideoTrack(obj);
}

WebCore::VideoTrack* core(WebKitDOMVideoTrack* request)
{
    return request ? static_cast<WebCore::VideoTrack*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMVideoTrack* wrapVideoTrack(WebCore::VideoTrack* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_VIDEO_TRACK(g_object_new(WEBKIT_DOM_TYPE_VIDEO_TRACK, "core-object", coreObject, nullptr));
}

} // namespace WebKit

#endif // ENABLE(VIDEO_TRACK)

G_DEFINE_TYPE(WebKitDOMVideoTrack, webkit_dom_video_track, WEBKIT_DOM_TYPE_OBJECT)

enum {
    PROP_0,
    PROP_ID,
    PROP_KIND,
    PROP_LABEL,
    PROP_LANGUAGE,
    PROP_SELECTED,
};

static void webkit_dom_video_track_finalize(GObject* object)
{
    WebKitDOMVideoTrackPrivate* priv = WEBKIT_DOM_VIDEO_TRACK_GET_PRIVATE(object);
#if ENABLE(VIDEO_TRACK)
    WebKit::DOMObjectCache::forget(priv->coreObject.get());
#endif // ENABLE(VIDEO_TRACK)
    priv->~WebKitDOMVideoTrackPrivate();
    G_OBJECT_CLASS(webkit_dom_video_track_parent_class)->finalize(object);
}

static void webkit_dom_video_track_set_property(GObject* object, guint propertyId, const GValue* value, GParamSpec* pspec)
{
    WebKitDOMVideoTrack* self = WEBKIT_DOM_VIDEO_TRACK(object);

    switch (propertyId) {
    case PROP_SELECTED:
        webkit_dom_video_track_set_selected(self, g_value_get_boolean(value));
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static void webkit_dom_video_track_get_property(GObject* object, guint propertyId, GValue* value, GParamSpec* pspec)
{
    WebKitDOMVideoTrack* self = WEBKIT_DOM_VIDEO_TRACK(object);

    switch (propertyId) {
    case PROP_ID:
        g_value_take_string(value, webkit_dom_video_track_get_id(self));
        break;
    case PROP_KIND:
        g_value_take_string(value, webkit_dom_video_track_get_kind(self));
        break;
    case PROP_LABEL:
        g_value_take_string(value, webkit_dom_video_track_get_label(self));
        break;
    case PROP_LANGUAGE:
        g_value_take_string(value, webkit_dom_video_track_get_language(self));
        break;
    case PROP_SELECTED:
        g_value_set_boolean(value, webkit_dom_video_track_get_selected(self));
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static GObject* webkit_dom_video_track_constructor(GType type, guint constructPropertiesCount, GObjectConstructParam* constructProperties)
{
    GObject* object = G_OBJECT_CLASS(webkit_dom_video_track_parent_class)->constructor(type, constructPropertiesCount, constructProperties);
#if ENABLE(VIDEO_TRACK)
    WebKitDOMVideoTrackPrivate* priv = WEBKIT_DOM_VIDEO_TRACK_GET_PRIVATE(object);
    priv->coreObject = static_cast<WebCore::VideoTrack*>(WEBKIT_DOM_OBJECT(object)->coreObject);
    WebKit::DOMObjectCache::put(priv->coreObject.get(), object);
#endif // ENABLE(VIDEO_TRACK)
    return object;
}

static void webkit_dom_video_track_class_init(WebKitDOMVideoTrackClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    g_type_class_add_private(gobjectClass, sizeof(WebKitDOMVideoTrackPrivate));
    gobjectClass->constructor = webkit_dom_video_track_constructor;
    gobjectClass->finalize = webkit_dom_video_track_finalize;
    gobjectClass->set_property = webkit_dom_video_track_set_property;
    gobjectClass->get_property = webkit_dom_video_track_get_property;

    g_object_class_install_property(
        gobjectClass,
        PROP_ID,
        g_param_spec_string(
            "id",
            "VideoTrack:id",
            "read-only gchar* VideoTrack:id",
            "",
            WEBKIT_PARAM_READABLE));

    g_object_class_install_property(
        gobjectClass,
        PROP_KIND,
        g_param_spec_string(
            "kind",
            "VideoTrack:kind",
            "read-only gchar* VideoTrack:kind",
            "",
            WEBKIT_PARAM_READABLE));

    g_object_class_install_property(
        gobjectClass,
        PROP_LABEL,
        g_param_spec_string(
            "label",
            "VideoTrack:label",
            "read-only gchar* VideoTrack:label",
            "",
            WEBKIT_PARAM_READABLE));

    g_object_class_install_property(
        gobjectClass,
        PROP_LANGUAGE,
        g_param_spec_string(
            "language",
            "VideoTrack:language",
            "read-only gchar* VideoTrack:language",
            "",
            WEBKIT_PARAM_READABLE));

    g_object_class_install_property(
        gobjectClass,
        PROP_SELECTED,
        g_param_spec_boolean(
            "selected",
            "VideoTrack:selected",
            "read-write gboolean VideoTrack:selected",
            FALSE,
            WEBKIT_PARAM_READWRITE));

}

static void webkit_dom_video_track_init(WebKitDOMVideoTrack* request)
{
    WebKitDOMVideoTrackPrivate* priv = WEBKIT_DOM_VIDEO_TRACK_GET_PRIVATE(request);
    new (priv) WebKitDOMVideoTrackPrivate();
}

gchar* webkit_dom_video_track_get_id(WebKitDOMVideoTrack* self)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_VIDEO_TRACK(self), 0);
    WebCore::VideoTrack* item = WebKit::core(self);
    gchar* result = convertToUTF8String(item->id());
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return 0;
#endif /* ENABLE(VIDEO_TRACK) */
}

gchar* webkit_dom_video_track_get_kind(WebKitDOMVideoTrack* self)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_VIDEO_TRACK(self), 0);
    WebCore::VideoTrack* item = WebKit::core(self);
    gchar* result = convertToUTF8String(item->kind());
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return 0;
#endif /* ENABLE(VIDEO_TRACK) */
}

gchar* webkit_dom_video_track_get_label(WebKitDOMVideoTrack* self)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_VIDEO_TRACK(self), 0);
    WebCore::VideoTrack* item = WebKit::core(self);
    gchar* result = convertToUTF8String(item->label());
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return 0;
#endif /* ENABLE(VIDEO_TRACK) */
}

gchar* webkit_dom_video_track_get_language(WebKitDOMVideoTrack* self)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_VIDEO_TRACK(self), 0);
    WebCore::VideoTrack* item = WebKit::core(self);
    gchar* result = convertToUTF8String(item->language());
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return 0;
#endif /* ENABLE(VIDEO_TRACK) */
}

gboolean webkit_dom_video_track_get_selected(WebKitDOMVideoTrack* self)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_VIDEO_TRACK(self), FALSE);
    WebCore::VideoTrack* item = WebKit::core(self);
    gboolean result = item->selected();
    return result;
#else
    UNUSED_PARAM(self);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
    return static_cast<gboolean>(0);
#endif /* ENABLE(VIDEO_TRACK) */
}

void webkit_dom_video_track_set_selected(WebKitDOMVideoTrack* self, gboolean value)
{
#if ENABLE(VIDEO_TRACK)
    WebCore::JSMainThreadNullState state;
    g_return_if_fail(WEBKIT_DOM_IS_VIDEO_TRACK(self));
    WebCore::VideoTrack* item = WebKit::core(self);
    item->setSelected(value);
#else
    UNUSED_PARAM(self);
    UNUSED_PARAM(value);
    WEBKIT_WARN_FEATURE_NOT_PRESENT("Video Track")
#endif /* ENABLE(VIDEO_TRACK) */
}

