/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMWebKitNamedFlow.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "GObjectEventListener.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMEventPrivate.h"
#include "WebKitDOMEventTarget.h"
#include "WebKitDOMNodeListPrivate.h"
#include "WebKitDOMNodePrivate.h"
#include "WebKitDOMPrivate.h"
#include "WebKitDOMWebKitNamedFlowPrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

#define WEBKIT_DOM_WEBKIT_NAMED_FLOW_GET_PRIVATE(obj) G_TYPE_INSTANCE_GET_PRIVATE(obj, WEBKIT_DOM_TYPE_WEBKIT_NAMED_FLOW, WebKitDOMWebKitNamedFlowPrivate)

typedef struct _WebKitDOMWebKitNamedFlowPrivate {
    RefPtr<WebCore::WebKitNamedFlow> coreObject;
} WebKitDOMWebKitNamedFlowPrivate;

namespace WebKit {

WebKitDOMWebKitNamedFlow* kit(WebCore::WebKitNamedFlow* obj)
{
    if (!obj)
        return 0;

    if (gpointer ret = DOMObjectCache::get(obj))
        return WEBKIT_DOM_WEBKIT_NAMED_FLOW(ret);

    return wrapWebKitNamedFlow(obj);
}

WebCore::WebKitNamedFlow* core(WebKitDOMWebKitNamedFlow* request)
{
    return request ? static_cast<WebCore::WebKitNamedFlow*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMWebKitNamedFlow* wrapWebKitNamedFlow(WebCore::WebKitNamedFlow* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_WEBKIT_NAMED_FLOW(g_object_new(WEBKIT_DOM_TYPE_WEBKIT_NAMED_FLOW, "core-object", coreObject, nullptr));
}

} // namespace WebKit

static gboolean webkit_dom_webkit_named_flow_dispatch_event(WebKitDOMEventTarget* target, WebKitDOMEvent* event, GError** error)
{
    WebCore::Event* coreEvent = WebKit::core(event);
    if (!coreEvent)
        return false;
    WebCore::WebKitNamedFlow* coreTarget = static_cast<WebCore::WebKitNamedFlow*>(WEBKIT_DOM_OBJECT(target)->coreObject);

    WebCore::ExceptionCode ec = 0;
    gboolean result = coreTarget->dispatchEventForBindings(*coreEvent, ec);
    if (ec) {
        WebCore::ExceptionCodeDescription description(ec);
        g_set_error_literal(error, g_quark_from_string("WEBKIT_DOM"), description.code, description.name);
    }
    return result;
}

static gboolean webkit_dom_webkit_named_flow_add_event_listener(WebKitDOMEventTarget* target, const char* eventName, GClosure* handler, gboolean useCapture)
{
    WebCore::WebKitNamedFlow* coreTarget = static_cast<WebCore::WebKitNamedFlow*>(WEBKIT_DOM_OBJECT(target)->coreObject);
    return WebCore::GObjectEventListener::addEventListener(G_OBJECT(target), coreTarget, eventName, handler, useCapture);
}

static gboolean webkit_dom_webkit_named_flow_remove_event_listener(WebKitDOMEventTarget* target, const char* eventName, GClosure* handler, gboolean useCapture)
{
    WebCore::WebKitNamedFlow* coreTarget = static_cast<WebCore::WebKitNamedFlow*>(WEBKIT_DOM_OBJECT(target)->coreObject);
    return WebCore::GObjectEventListener::removeEventListener(G_OBJECT(target), coreTarget, eventName, handler, useCapture);
}

static void webkit_dom_event_target_init(WebKitDOMEventTargetIface* iface)
{
    iface->dispatch_event = webkit_dom_webkit_named_flow_dispatch_event;
    iface->add_event_listener = webkit_dom_webkit_named_flow_add_event_listener;
    iface->remove_event_listener = webkit_dom_webkit_named_flow_remove_event_listener;
}

G_DEFINE_TYPE_WITH_CODE(WebKitDOMWebKitNamedFlow, webkit_dom_webkit_named_flow, WEBKIT_DOM_TYPE_OBJECT, G_IMPLEMENT_INTERFACE(WEBKIT_DOM_TYPE_EVENT_TARGET, webkit_dom_event_target_init))

enum {
    PROP_0,
    PROP_NAME,
    PROP_OVERSET,
    PROP_FIRST_EMPTY_REGION_INDEX,
};

static void webkit_dom_webkit_named_flow_finalize(GObject* object)
{
    WebKitDOMWebKitNamedFlowPrivate* priv = WEBKIT_DOM_WEBKIT_NAMED_FLOW_GET_PRIVATE(object);

    WebKit::DOMObjectCache::forget(priv->coreObject.get());

    priv->~WebKitDOMWebKitNamedFlowPrivate();
    G_OBJECT_CLASS(webkit_dom_webkit_named_flow_parent_class)->finalize(object);
}

static void webkit_dom_webkit_named_flow_get_property(GObject* object, guint propertyId, GValue* value, GParamSpec* pspec)
{
    WebKitDOMWebKitNamedFlow* self = WEBKIT_DOM_WEBKIT_NAMED_FLOW(object);

    switch (propertyId) {
    case PROP_NAME:
        g_value_take_string(value, webkit_dom_webkit_named_flow_get_name(self));
        break;
    case PROP_OVERSET:
        g_value_set_boolean(value, webkit_dom_webkit_named_flow_get_overset(self));
        break;
    case PROP_FIRST_EMPTY_REGION_INDEX:
        g_value_set_long(value, webkit_dom_webkit_named_flow_get_first_empty_region_index(self));
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static GObject* webkit_dom_webkit_named_flow_constructor(GType type, guint constructPropertiesCount, GObjectConstructParam* constructProperties)
{
    GObject* object = G_OBJECT_CLASS(webkit_dom_webkit_named_flow_parent_class)->constructor(type, constructPropertiesCount, constructProperties);

    WebKitDOMWebKitNamedFlowPrivate* priv = WEBKIT_DOM_WEBKIT_NAMED_FLOW_GET_PRIVATE(object);
    priv->coreObject = static_cast<WebCore::WebKitNamedFlow*>(WEBKIT_DOM_OBJECT(object)->coreObject);
    WebKit::DOMObjectCache::put(priv->coreObject.get(), object);

    return object;
}

static void webkit_dom_webkit_named_flow_class_init(WebKitDOMWebKitNamedFlowClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    g_type_class_add_private(gobjectClass, sizeof(WebKitDOMWebKitNamedFlowPrivate));
    gobjectClass->constructor = webkit_dom_webkit_named_flow_constructor;
    gobjectClass->finalize = webkit_dom_webkit_named_flow_finalize;
    gobjectClass->get_property = webkit_dom_webkit_named_flow_get_property;

    g_object_class_install_property(
        gobjectClass,
        PROP_NAME,
        g_param_spec_string(
            "name",
            "WebKitNamedFlow:name",
            "read-only gchar* WebKitNamedFlow:name",
            "",
            WEBKIT_PARAM_READABLE));

    g_object_class_install_property(
        gobjectClass,
        PROP_OVERSET,
        g_param_spec_boolean(
            "overset",
            "WebKitNamedFlow:overset",
            "read-only gboolean WebKitNamedFlow:overset",
            FALSE,
            WEBKIT_PARAM_READABLE));

    g_object_class_install_property(
        gobjectClass,
        PROP_FIRST_EMPTY_REGION_INDEX,
        g_param_spec_long(
            "first-empty-region-index",
            "WebKitNamedFlow:first-empty-region-index",
            "read-only glong WebKitNamedFlow:first-empty-region-index",
            G_MINLONG, G_MAXLONG, 0,
            WEBKIT_PARAM_READABLE));

}

static void webkit_dom_webkit_named_flow_init(WebKitDOMWebKitNamedFlow* request)
{
    WebKitDOMWebKitNamedFlowPrivate* priv = WEBKIT_DOM_WEBKIT_NAMED_FLOW_GET_PRIVATE(request);
    new (priv) WebKitDOMWebKitNamedFlowPrivate();
}

WebKitDOMNodeList* webkit_dom_webkit_named_flow_get_regions_by_content(WebKitDOMWebKitNamedFlow* self, WebKitDOMNode* contentNode)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_WEBKIT_NAMED_FLOW(self), 0);
    g_return_val_if_fail(WEBKIT_DOM_IS_NODE(contentNode), 0);
    WebCore::WebKitNamedFlow* item = WebKit::core(self);
    WebCore::Node* convertedContentNode = WebKit::core(contentNode);
    RefPtr<WebCore::NodeList> gobjectResult = WTF::getPtr(item->getRegionsByContent(convertedContentNode));
    return WebKit::kit(gobjectResult.get());
}

WebKitDOMNodeList* webkit_dom_webkit_named_flow_get_regions(WebKitDOMWebKitNamedFlow* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_WEBKIT_NAMED_FLOW(self), 0);
    WebCore::WebKitNamedFlow* item = WebKit::core(self);
    RefPtr<WebCore::NodeList> gobjectResult = WTF::getPtr(item->getRegions());
    return WebKit::kit(gobjectResult.get());
}

WebKitDOMNodeList* webkit_dom_webkit_named_flow_get_content(WebKitDOMWebKitNamedFlow* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_WEBKIT_NAMED_FLOW(self), 0);
    WebCore::WebKitNamedFlow* item = WebKit::core(self);
    RefPtr<WebCore::NodeList> gobjectResult = WTF::getPtr(item->getContent());
    return WebKit::kit(gobjectResult.get());
}

gchar* webkit_dom_webkit_named_flow_get_name(WebKitDOMWebKitNamedFlow* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_WEBKIT_NAMED_FLOW(self), 0);
    WebCore::WebKitNamedFlow* item = WebKit::core(self);
    gchar* result = convertToUTF8String(item->name());
    return result;
}

gboolean webkit_dom_webkit_named_flow_get_overset(WebKitDOMWebKitNamedFlow* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_WEBKIT_NAMED_FLOW(self), FALSE);
    WebCore::WebKitNamedFlow* item = WebKit::core(self);
    gboolean result = item->overset();
    return result;
}

glong webkit_dom_webkit_named_flow_get_first_empty_region_index(WebKitDOMWebKitNamedFlow* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_WEBKIT_NAMED_FLOW(self), 0);
    WebCore::WebKitNamedFlow* item = WebKit::core(self);
    glong result = item->firstEmptyRegionIndex();
    return result;
}

